"use strict";

var fs = require('fs');

var path = require('path');

var webpack = require('webpack');

var _require = require('rax'),
    createElement = _require.createElement;

var renderer = require('rax-server-renderer');

var interopRequire = require('./interopRequire');

var getWebpackNodeConfig = require('./getWebpackNodeConfig');

var AppShellHandler =
/*#__PURE__*/
function () {
  function AppShellHandler(options) {
    this.options = options;
    var appDirectory = this.options.appDirectory;
    this.tempShellFileName = '_shell';
    this.tempShellFilePath = path.resolve(appDirectory, '.temp', this.tempShellFileName + '.js');
  }

  var _proto = AppShellHandler.prototype;

  _proto.build = function build(next) {
    var _this$options = this.options,
        appDirectory = _this$options.appDirectory,
        appShell = _this$options.appShell;
    var webpackShellConfig = getWebpackNodeConfig(appDirectory);
    webpackShellConfig.entry[this.tempShellFileName] = appShell;
    webpack(webpackShellConfig).run(function () {
      next('appShell');
    });
  };

  _proto.getContent = function getContent() {
    var content = renderer.renderToString(createElement(interopRequire(eval(fs.readFileSync(this.tempShellFilePath, 'utf-8'))), {
      Component: function Component() {
        return createElement('div', {
          id: 'root-page'
        });
      }
    }));
    return content;
  };

  return AppShellHandler;
}();

module.exports = AppShellHandler;