"use strict";

/**
 * PWA Plugin
 * Add or modify some project files according to the configuration of project app.json,
 * update the construction configuration, and achieve the purpose of experience enhancement
 *
 */
var RaxPWAPlugins = require('./config/RaxPWAPlugins');

var RaxPWAPlugin =
/*#__PURE__*/
function () {
  function RaxPWAPlugin(options) {
    this.options = options;
  }

  var _proto = RaxPWAPlugin.prototype;

  _proto.apply = function apply(compiler) {
    var _this = this;

    if (Array.isArray(compiler.options.plugins)) {
      RaxPWAPlugins.forEach(function (Plugin) {
        compiler.options.plugins.push(new Plugin(_this.options));
      });
    }
  };

  return RaxPWAPlugin;
}();

module.exports = RaxPWAPlugin;