"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var fs = require('fs');

var path = require('path');

var pathToRegexp = require('path-to-regexp');

var getSPAPagesConfig = function getSPAPagesConfig(appConfig, pathConfig) {
  var pagesConfig = {};
  var customePageConfig = appConfig.pages || {};
  fs.readdirSync(path.join(pathConfig.appSrc, 'pages')).map(function (file) {
    if (fs.statSync(path.join(pathConfig.appSrc, 'pages', file)).isDirectory()) {
      pagesConfig[file] = _extends({
        path: "/" + file
      }, customePageConfig[file]);
      pagesConfig[file]._regexp = pathToRegexp(pagesConfig[file].path).toString();
      pagesConfig[file]._filePath = path.join(pathConfig.appSrc, "pages/" + file + "/index");
    }
  });
  return pagesConfig;
};

module.exports = getSPAPagesConfig;