"use strict";

var qs = require('querystring');

module.exports = function (source) {
  var query = typeof this.query === 'string' ? qs.parse(this.query.substr(1)) : this.query;
  var ssr = query.ssr,
      withAppShell = query.withAppShell;
  var code = source;

  if (ssr === 'true') {
    var functionName = '_PWA_page_component_';
    var renderCodeStr = withAppShell === 'true' ? "render(createElement(AppShell, Object.assign(data || {}, { Component: function(props) {return createElement(" + functionName + ", props || {}); }})), document.getElementById('root'), { driver: DriverDOM, hydrate: true });" : "render(createElement(" + functionName + ", data || {}), document.getElementById('root'), { driver: DriverDOM, hydrate: true });"; // Get target function name

    if (code.indexOf('export default') !== -1) {
      // export default function ...
      // export default Index
      code = source.replace('export default', "var " + functionName + " =");
    } else {
      // export { Index as default };
      // export { Index }
      var test = /export { (\S*) }/.exec(code);

      if (test) {
        code += "var " + functionName + " = " + test[1];
      }
    }

    code += "\n      import {render} from 'rax';\n      import * as DriverDOM from 'driver-dom';\n      " + (withAppShell === 'true' ? "import AppShell from '../../shell/';" : '') + "\n      window.addEventListener( \"load\", function(){\n        var data = null;\n        try {\n          data = JSON.parse(document.querySelector(\"[data-from='server']\").innerHTML);\n        } catch (e) {\n          // ignore\n        }\n        if (data !== null || !" + functionName + ".getInitialProps) {\n          renderComponent();\n        } else {\n          " + functionName + ".getInitialProps().then(renderComponent);\n        }\n\n        function renderComponent() {\n          " + renderCodeStr + "\n        }\n      })\n    ";
  }

  return code;
};