"use strict";

var _querystring = require("querystring");

module.exports = function (source) {
  var query = typeof this.query === 'string' ? (0, _querystring.parse)(this.query.substr(1)) : this.query;
  var page = query.page,
      appPath = query.appPath,
      appConfigPath = query.appConfigPath,
      appDocumentPath = query.appDocumentPath,
      appShellPath = query.appShellPath,
      assetsManifestPath = query.assetsManifestPath;
  return "\n    import RaxServer from 'rax-server';\n\n    import App from '" + appPath + "';\n    " + (appDocumentPath ? "import Document from '" + appDocumentPath + "';" : '') + "\n    " + (appShellPath ? "import Shell from '" + appShellPath + "';" : '') + "\n    import appConfig from '" + appConfigPath + "';\n    import assetsManifest from '" + assetsManifestPath + "';\n\n    const assets = assetsManifest['" + page + "'];\n    const server = new RaxServer({\n      document: {\n        title: appConfig.title,\n        " + (appDocumentPath ? 'component: Document' : '') + "\n      },\n      shell: {\n        " + (appShellPath ? 'component: Shell' : '') + "\n      },\n      pages: {\n        '" + page + "': {\n          title: appConfig.pages && appConfig.pages['" + page + "'] ? appConfig.pages['" + page + "'].title : '',\n          component: App,\n          ...assets\n        }\n      }\n    });\n\n    export async function render(req, res) {\n      try {\n        server.render(req, res, {\n          page: '" + page + "'\n        });\n      } catch (err) {\n        console.error(err);\n        res.statusCode = 500;\n        res.send('Internal Server Error');\n      }\n    }\n\n    export function initializer(context, callback) {\n      callback(null, '');\n    }\n  ";
};